/* license: AGPLv3 or later */
/* copyright 2024 zamfofex */

#include <mimimi.h>

void mimimi_camera_tick(struct mimimi_position *camera, struct mimimi_position *position, int ox, int oy)
{
	camera->x *= 3;
	camera->y *= 3;
	camera->x += position->x + ox;
	camera->y += position->y + oy;
	camera->x /= 4;
	camera->y /= 4;
}

void mimimi_clamped_camera_tick(struct mimimi_clamped_camera *camera, int width0, int height0)
{
	struct mimimi_position *input;
	struct mimimi_position *output;
	int x, y, width, height;
	int left, right;
	int top, bottom;
	
	input = camera->input;
	output = &camera->output;
	
	x = camera->offset.x;
	y = camera->offset.y;
	width = camera->size.width;
	height = camera->size.height;
	
	left = x * 128;
	right = left + width * 128;
	
	top = y * 128;
	bottom = top + height * 128;
	
	left += width0 * 4;
	right -= width0 * 4;
	top += height0 * 4;
	bottom -= height0 * 4;
	
	*output = *input;
	
	if (output->x < left) output->x = left;
	if (output->x > right) output->x = right;
	if (output->y < top) output->y = top;
	if (output->y > bottom) output->y = bottom;
}
