/* license: AGPLv3 or later */
/* copyright 2024 zamfofex */

#ifndef MIMIMI_CHAPTERS_H
#define MIMIMI_CHAPTERS_H

#include <mimimi.h>

struct mimimi_test
{
	struct mimimi_engine *engine;
	struct mimimi_history history;
	struct mimimi_stage stage;
};

void mimimi_test_tick(void *chapter, unsigned char left, unsigned char right);
void *mimimi_test(struct mimimi_engine *engine);

struct mimimi_chapter_I
{
	struct mimimi_engine *engine;
	struct mimimi_history history;
	int progression;
	int progression_counter;
	struct mimimi_toast_dialogue dialogue0, dialogue1, dialogue;
	struct mimimi_stage stage;
};

void mimimi_chapter_I_tick(void *chapter, unsigned char left, unsigned char right);
void *mimimi_chapter_I(struct mimimi_engine *engine);

struct mimimi_loader
{
	struct mimimi_engine *engine;
	int previous_direction;
	int x;
	unsigned char colors[0x100000];
	struct mimimi_image images[0x10];
	void *textures[0x10];
	void *background;
	struct mimimi_image background_image;
	int index;
	unsigned char started;
	void *chapter;
};

void mimimi_loader_tick(void *chapter, unsigned char left, unsigned char right);
void *mimimi_loader(struct mimimi_engine *engine);

#endif
